PLaSK library

Loading...
Searching...
No Matches
Public Member Functions | List of all members
plask::MaterialsDB::ProxyMaterialConstructor Class Reference

Material constructor that holds other constructor or complete material object based on the provided name. More...

`#include <plask/material/db.hpp>`

Inheritance diagram for plask::MaterialsDB::ProxyMaterialConstructor:
[legend]
Collaboration diagram for plask::MaterialsDB::ProxyMaterialConstructor:
[legend]

## Public Member Functions
| ProxyMaterialConstructor ()
| ProxyMaterialConstructor (const std::string &name, const MaterialsDB &db=MaterialsDB::getDefault())
| ProxyMaterialConstructor (const shared_ptr< Material > &material)
shared_ptr< Material > | operator() (const Material::Composition &comp, double dop) const override
| Create material.
bool | isAlloy () const override
Public Member Functions inherited from plask::MaterialsDB::MaterialConstructor
| MaterialConstructor (const std::string &materialName)
| MaterialConstructor constructor.
virtual | ~MaterialConstructor ()
void | ensureCompositionIsEmpty (const Material::Composition &composition) const
void | ensureNoDoping (double doping) const

## Additional Inherited Members
Public Attributes inherited from plask::MaterialsDB::MaterialConstructor
std::string | materialName
| Full name (with optional dopant name) of material which this constructor can create.

## Detailed Description

Material constructor that holds other constructor or complete material object based on the provided name.

Definition at line 436 of file db.hpp.

## Constructor & Destructor Documentation

## ◆ ProxyMaterialConstructor() [1/3]

plask::MaterialsDB::ProxyMaterialConstructor::ProxyMaterialConstructor | ( |  | ) |

Definition at line 155 of file db.cpp.

## ◆ ProxyMaterialConstructor() [2/3]

plask::MaterialsDB::ProxyMaterialConstructor::ProxyMaterialConstructor | ( | const std::string & | name,
|  | const MaterialsDB & | db = `MaterialsDB::getDefault()`
| ) |  |

Definition at line 159 of file db.cpp.

## ◆ ProxyMaterialConstructor() [3/3]

plask::MaterialsDB::ProxyMaterialConstructor::ProxyMaterialConstructor | ( | const shared_ptr< Material > & | material | ) |

Definition at line 177 of file db.cpp.

## Member Function Documentation

## ◆ isAlloy()

bool plask::MaterialsDB::ProxyMaterialConstructor::isAlloy | ( |  | ) | const
| override virtual

Returns
  `true` only if this constructor creates simple material (does not use composition)

Implements plask::MaterialsDB::MaterialConstructor.

Definition at line 193 of file db.cpp.

## ◆ operator()()

shared_ptr< Material > plask::MaterialsDB::ProxyMaterialConstructor::operator() | ( | const Material::Composition & | composition,
|  | double | doping
| ) |  | const
| override virtual

Create material.

Parameters

  composition | parsed amounts of objects, can be not completed (see Material::completeComposition), empty composition in case of simple materials
  doping | amount of dopant

Returns
  created material

Implements plask::MaterialsDB::MaterialConstructor.

Definition at line 181 of file db.cpp.

The documentation for this class was generated from the following files:

- plask/material/db.hpp
- plask/material/db.cpp